gio.AsyncResult
Prev | PyGio Class Reference | Next

## gio.AsyncResult

gio.AsyncResult — Asynchronous Function Results.

## Synopsis

    class gio.AsyncResult(gobject.GInterface):
        def get_source_object()

## Ancestry

    +-- gobject.GInterface
      +-- gio.AsyncResult

## Prerequisites

`gio.AsyncResult` is required by `gobject.GObject`.

## Known Implementation

`gio.AsyncResult` is implemented by `gio.SimpleAsyncResult`.

## Description

`gio.AsyncResult` provides a base class for implementing asynchronous function results.

Asynchronous operations are broken up into two separate operations which are chained together by a GAsyncReadyCallback. To begin an asynchronous operation, provide a GAsyncReadyCallback to the asynchronous function. This callback will be triggered when the operation has completed, and will be passed a GAsyncResult instance filled with the details of the operation's success or failure, the object the asynchronous function was started for and any error codes returned. The asynchronous callback function is then expected to call the corresponding "_finish()" function with the object the function was called for, and the `gio.AsyncResult` instance, and optionally, an error to grab any error conditions that may have occurred.

The purpose of the "_finish()" function is to take the generic result of type GAsyncResult and return the specific result that the operation in question yields (e.g. a `gio.FileEnumerator` for a "enumerate children" operation). If the result or error status of the operation is not needed, there is no need to call the "_finish()" function, GIO will take care of cleaning up the result and error information after the GAsyncReadyCallback returns. It is also allowed to take a reference to the `gio.AsyncResult` and call "_finish()" later.

The callback for an asynchronous operation is called only once, and is always called, even in the case of a cancelled operation. On cancellation the result is a gio.ERROR_CANCELLED error.

Some ascynchronous operations are implemented using synchronous calls. These are run in a separate thread, if GThread has been initialized, but otherwise they are sent to the Main Event Loop and processed in an idle function. So, if you truly need asynchronous operations, make sure to initialize GThread.

## Methods

### gio.AsyncResult.get_source_object

        def get_source_object()

Returns : | the source object for the res.

The `get_source_object`() method gets the source object from a `gio.AsyncResult`

Prev | Up | Next
gio.AppLaunchContext | Home | gio.BufferedInputStream